<?php

/**
 * Copyright 2014 SURFnet bv
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

namespace Surfnet\Stepup\Identity\Event;

use Surfnet\Stepup\Identity\Collection\InstitutionCollection;

class InstitutionsAddedToWhitelistEvent implements WhitelistEvent
{
    /**
     * @var InstitutionCollection
     */
    public $addedInstitutions;

    public function __construct(InstitutionCollection $addedInstitutions)
    {
        $this->addedInstitutions = $addedInstitutions;
    }

    /**
     * @param array $data
     * @return InstitutionsAddedToWhitelistEvent
     */
    public static function deserialize(array $data)
    {
        return new self(InstitutionCollection::deserialize($data['added_institutions']));
    }

    /**
     * @return array
     */
    public function serialize(): array
    {
        return ['added_institutions' => $this->addedInstitutions->serialize()];
    }
}
